<?php
// $Id: 6ga-panel.php,v 1.29 2011/11/09 06:38:29 hiro Exp $
//
// 6ga-panel.php
//
//
//
//	Copyright (c) 2005 Hiro Sugawara
//	Licensed under terms of GPL 2.0
//
include('6ga-common.inc');

// UI constants
$ABGCOLOR	= array('schedule'	=> 'green',
					'cancel'	=> 'red',
					'abort'		=> 'red',
					'stop'		=> 'red',
					'delete'	=> 'blue');
$AFGCOLOR	= array('schedule'	=> 'white',
					'cancel'	=> 'white',
					'abort'		=> 'white',
					'stop'		=> 'white',
					'delete'	=> 'white');
$ACTION		= array('schedule'	=> 'Schedule',
					'cancel'	=> 'Cancel',
					'abort'		=> 'Abort',
					'stop'		=> 'Stop transferring',
					'delete'	=> 'Delete');

// Retrieve iEPG parameters
saveiepg();

$bgcolor = $TABCOLOR[$thistab];

//
// Form for scheduling a new recording
//
function scheduleOption($iepg) {
	global $abgcolor;

	// Get day of the week to see if this is a weekday program
	$dow = getDOW($iepg);
	$weekday = ($dow != 'Sun' && $dow != 'Sat');

	echo <<<END
<FORM ACTION='6ga-schedule.php' METHOD=GET ACCEPT-CHARSET='shift_jis'>
<TABLE WIDTH='100%' BGCOLOR='$abgcolor' CELLPADDING=0>
<TR HEIGHT=12 VALIGN='baseline'>
<TD><FONT COLOR='white'>
	&nbsp;Schedule for
	<INPUT NAME='program' TYPE=RADIO VALUE='once' CHECKED>
	single time or every
	<INPUT NAME='program' TYPE=RADIO VALUE='$dow'>
	$dow&nbsp;&nbsp;
END;
	// A weekday program may be broadcast 5 days a week
	if ($weekday) {
		echo <<<END
	<INPUT NAME='program' TYPE=RADIO VALUE='M-F'>
	M-F
END;
	}

	// Pass IEPG parameters as hidden inputs
	foreach (array_keys($iepg) as $key) {
		// Pass single quotes (apostrophes) in URI format
		printf("<INPUT TYPE=HIDDEN NAME='iepg_$key' VALUE='%s'>\n",
				preg_replace("/'/", "%27", $iepg[$key]));
	}
	echo <<<END
</FONT></TD>
</TR>
<TR>
<TD ALIGN='right'>
<INPUT TYPE=SUBMIT NAME='choice' VALUE='schedule'>
<INPUT TYPE=SUBMIT NAME='choice' VALUE='cancel'>
</TD>
</TR>
</TABLE>
</FORM>
END;
}

//
// Form for cancelling a scheduled recording
//
function cancelOption($iepg) {
	global $thisfile, $thistab, $abgcolor;

	echo <<<END
<FORM ACTION='6ga-cancel.php' METHOD=GET>
<INPUT TYPE=HIDDEN NAME='file' VALUE='$thisfile'>
<TABLE WIDTH='100%' BGCOLOR='$abgcolor' CELLPADDING=0>
END;

	// If this is an episode of a regularly scheduled series, there are options
	if ($thistab == 'scheduled' && @$iepg['every']) {
		echo <<<END
<TR HEIGHT=12 VALIGN='baseline'>
<TD><FONT COLOR='white'>
	<INPUT NAME='program' TYPE=RADIO VALUE='skip' CHECKED>
	Skip this only&nbsp;
	<INPUT NAME='program' TYPE=RADIO VALUE='cancelall'>
	Cancel this and all future episodes
END;
	}

	echo <<<END
</FONT></TD>
</TR>
<TR>
<TD ALIGN='right'>
<INPUT TYPE=SUBMIT NAME='choice' VALUE='cancel'>
<INPUT TYPE=SUBMIT NAME='choice' VALUE='keep'>
</TD>
</TR>
</TABLE>
</FORM>
END;
}

//
// Form for deleting a recorded program
//
function deleteOption($iepg) {
	global $thisfile, $thistab, $abgcolor;
	global $VIDEOROOTDIR;

	echo <<<END
<FORM ACTION='6ga-delete.php' METHOD=GET>
<INPUT TYPE=HIDDEN NAME='file' VALUE='$thisfile'>
<TABLE WIDTH='100%' BGCOLOR='$abgcolor' CELLPADDING=0>
END;

	echo <<<END
</FONT></TD>
</TR>
<TR>
<TD ALIGN='right'>
END;

	// FIX ME - ugly to use $VIDEOROOTDIR...
	if (file_exists("$VIDEOROOTDIR/$thistab/$thisfile.xfrd")
		|| read_file("$VIDEOROOTDIR/$thistab/$thisfile.stat") == 'Failed') {
		echo <<<END
<INPUT TYPE=SUBMIT NAME='choice' VALUE='refresh'>
END;
	}

	echo <<<END
<INPUT TYPE=SUBMIT NAME='choice' VALUE='delete'>
<INPUT TYPE=SUBMIT NAME='choice' VALUE='keep'>
</TD>
</TR>
</TABLE>
</FORM>
END;
}

//
// Form for aborting/stopping an ongoing process
//
function abortstopOption($iepg, $abortstop) {
	global $thisfile, $thistab, $abgcolor;
	global $VIDEOROOTDIR;

	echo <<<END
<FORM ACTION='6ga-abort.php' METHOD=GET>
<INPUT TYPE=HIDDEN NAME='file' VALUE='$thisfile'>
<TABLE WIDTH='100%' BGCOLOR='$abgcolor' CELLPADDING=0>
END;

	echo <<<END
</FONT></TD>
</TR>
<TR>
<TD ALIGN='right'>
<INPUT TYPE=SUBMIT NAME='choice' VALUE='$abortstop'>
<INPUT TYPE=SUBMIT NAME='choice' VALUE='continue'>
</TD>
</TR>
</TABLE>
</FORM>
END;
}

function abortOption($iepg) {
	abortstopOption($iepg, 'abort');
}

function stopOption($iepg) {
	abortstopOption($iepg, 'stop');
}

printDocHeader();
?>
<HTML>
<HEAD>
<STYLE TYPE="text/css">
<!--
A {text-decoration:none}
A.anchor {
	color: #000000;
}
A:visited {
	color: #000000;
}
A:hover {
	color: #ff3f00;
	text-decoration: underline;
}
-->
</STYLE>
<meta http-equiv="Content-Type" content="text/html;charset=shift_jis" />
</HEAD>
<?php

//
// Code body starts here
//
if ($action) {
	printf("<BODY BGCOLOR='$bgcolor'>\n");

	$abgcolor	= $ABGCOLOR[$action];
	$afgcolor	= $AFGCOLOR[$action];
	$atext		= $ACTION[$action];

	if ($action == 'cancel'
		|| $action == 'abort'
		|| $action == 'stop'
		|| $action == 'delete') {
		$list	= openList($thistab);
		readList($list, $thisfile);
		closeList($list);
		foreach (array_keys($list['iepg']) as $key) {
			$iepg[$key]	= $list['iepg'][$key];
		}
	}

	$_station	= $iepg['station'];
	if ($thistab == 'regular') {
		$_datetime	= @$iepg['every'];
	} else {
		$_datetime	= sprintf("%s/%s", $iepg['month'], $iepg['date']);
	}

	$minutes	= programTime($iepg);
	$_datetime	.= sprintf(" %s<BR>%dh%02dm",
							$iepg['start'], $minutes/60, $minutes%60);
	if ($thistab != 'regular' && @$iepg['every']) {
		$_datetime .= ' ' . $iepg['every'];
	}
	$_subtitle = @$iepg['program-subtitle'] ?
			preg_replace('/\x81\x42.*$/', '', $iepg['program-subtitle']) : '';
	$_title	 = sprintf("%s<BR>%s", $iepg['program-title'], $_subtitle);
	echo <<<END
<TABLE WIDTH='100%' BORDER=0 CELLPADDING=5 VSPACE=0>
<TR><TD BGCOLOR='$bgcolor'>
	<TABLE WIDTH='100%' BGCOLOR='white' BORDER=0 CELLPADDING=1 VSPACE=0>
	<TR><TD>
		<TABLE WIDTH='100%' BGCOLOR='$abgcolor' CELLPADDING=2 VSPACE=0>
		<TR><TD><CENTER>
			<FONT COLOR='$afgcolor'>
			<B>$atext the following program?</B>
			</FONT></CENTER></TD></TR>
		</TD></TR>
		<TR><TD>
			<TABLE WIDTH='100%' BGCOLOR='$abgcolor' CELLPADDING=5 VSPACE=0>
			<TR>
				<TD WIDTH=40 BGCOLOR='white'>$_station</TD>
				<TD WIDTH=70 BGCOLOR='white'>$_datetime</TD>
				<TD BGCOLOR='white' VALIGN='middle'>$_title</TD>
			</TR>
			</TABLE>
		</TD></TR>
		<TR><TD>
END;

	$function	= $action . 'Option';
	$function($iepg);

	echo <<<END
		</TD></TR>
		</TABLE>
	</TD></TR>
	</TABLE>
</TD></TR>
</TABLE>
</BODY>
END;
} else {
	// No action case. Display a real-time clock and calendar
	$bgcolor_u	= urlencode($bgcolor);

$now	= time();
echo <<<_EOS
<SCRIPT LANGUAGE='JavaScript'>
<!--

function loadDocs() {
	document.open('6ga-list.php?tab=$thistab&_time=$now', '_6ga_list');
	usnotime();
}

//-->
</SCRIPT>
<FRAMESET COLS='180,*' FRAMEBORDER=0 FRAMESPACING=0 BGCOLOR=$bgcolor>
	<FRAME NAME='rclock' SRC='6ga-rclock.php?bgcolor=$bgcolor_u'
		MARGINWIDTH='0' MARGINHEIGHT='0' SCROLLING='no' NORESIZE>
	<FRAME NAME='calendar' SRC='6ga-calendar.php?bgcolor=$bgcolor_u'
		MARGINWIDTH='0' MARGINHEIGHT='0' SCROLLING='auto' NORESIZE>
</FRAMESET>
_EOS;
}
?>
</HTML>
