<?php
// $Id: 6ga-sview.php,v 1.35 2011/11/09 06:36:37 hiro Exp $
//
// 6ga-sview.php
//
//	Copyright (c) 2009 Hiro Sugawara
//	Licensed under terms of GPL 2.0
//
//	Scheduled program viewer
//
//	Arguments:
//
include('6ga-common.inc');
printDocHeader();

if (@$thistab != 'scheduled' && @$thistab != 'regular') {
	$thistab = 'scheduled';
}
$daykey	= ($thistab == 'scheduled') ? 'yyyymmdd' : 'dow';


$COLSPERDAY	= 1;
$numvideodevices	= $NUMVIDEODEVICES + 1;
while ($numvideodevices > 1) {
	$COLSPERDAY *= $numvideodevices;
	$numvideodevices--;
}

$displayed	= array();
$scheduled	= array();
$RECCOLOR	= 'lightgreen';
$NOWCOLOR	= 'red';
$WARNCOLOR	= 'red';

$today	= '';
$ntime	= '';
$DOW	= array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
$CHCOLOR	= array(
		1	=> 'lightblue',
		3	=> 'yellow',
		4	=> 'pink',
		5	=> 'lightyellow',
		6	=> 'white',
		8	=> 'grey',
		10	=> 'lightgrey',
		12	=> 'orange',
		14	=> 'lightgreen',
		16	=> 'lightyellow',

		927	=> 'lightblue',
		926	=> 'yellow',
		925	=> 'pink',

		922	=> 'white',
		921	=> 'grey',
		924	=> 'lightgrey',
		923	=> 'orange',
		928	=> 'lightgreen',

		'GR27'	=> 'lightblue',
		'GR26'	=> 'yellow',
		'GR25'	=> 'pink',

		'GR22'	=> 'white',
		'GR21'	=> 'grey',
		'GR24'	=> 'lightgrey',
		'GR23'	=> 'orange',
		'GR28'	=> 'lightgreen',
	);


function hrBorder() {
	global $DOW, $COLSPERDAY;
	global $displayed;

	printf("<TR BGCOLOR=black HEIGHT=1>\n");
	foreach ($displayed as $disp) {
		if (!$disp['irm']) {
			for ($i = 0; $i < $COLSPERDAY; $i++) {
				printf("<TD WIDTH=%d%%></TD>\n",
						100/(count($displayed) * $COLSPERDAY));
			}
		}
	}
	printf("</TR>\n");
}

function blnkcolor($disp, $time) {
	global $RECCOLOR;
	global $today;
	global $ntime;

	$bgcset	= $disp['blnkcolor'];
	sscanf($time, "%d:", $t);
	$bgcolor	= $bgcset[$t/6];
	if ($t < 24 && $disp['yyyymmdd'] <= $today && $time <= $ntime) {
		// Already recorded
		$bgcolor	= $RECCOLOR;
	}
	return sprintf("BGCOLOR=%s", $bgcolor);
}

function showDayIndex($thick, $time='00:00') {
	global $DOW;
	global $COLSPERDAY;
	global $displayed;
	global $thistab;
	$thd	= ($thick ? 'TH'	: 'TD');

	hrBorder();
	printf("<TR>\n");
	foreach ($displayed as $disp) {
		if (!$disp['irm']) {
			$date	= '';
			if ($thistab == 'scheduled') {
				$date	= sprintf("%d/%02d ", $disp['month'], $disp['dom']);
			}
			$date	.= sprintf("[%s]", $disp['dow']);
			printf(
	"<%s COLSPAN=%d WIDTH=%d%% %s><CENTER>%s</CENTER></%s>\n",
				$thd,
				$COLSPERDAY,
				100/count($DOW),
				blnkcolor($disp, $time),
				$date,
				$thd);
		}
	}
	printf("</TR>\n");
	hrBorder();
}

$tline	= array();

function tlkey($a, $key) {
	if ($key == 'end') {
		sscanf($a['start'], "%d:%d", $sh, $sm);
		sscanf($a['end'], "%d:%d", $eh, $em);

		// Take care of 24:00 and beyond
		if ($sh > $eh)
			return sprintf("%02d:%02d E", $eh + 24, $em);
	}
	return sprintf("%s %s", $a[$key], ($key == 'start') ? 'S' : 'E');
}

function scanList($list, $tab) {
	global $CHCOLOR, $RECCOLOR, $NOWCOLOR, $WARNCOLOR;
	global $nowhhmm;
	global $displayed, $scheduled;
	global $tline;
	global $thistab;
	global $VIDEOROOTDIR;

	$iepg	= $list['iepg'];
	if ($thistab == 'scheduled') {
		$yyyymmdd = sprintf("%4d%02d%02d",
						$iepg['year'], $iepg['month'], $iepg['date']);
	} else if ($iepg['every'] == 'M-F') {
		// Break own DOWs and recursively call myself
		foreach (array('Mon', 'Tue', 'Wed', 'Thu', 'Fri') as $dow) {
			$list2	= $list;
			$list2['iepg']['every']	= $dow;
			$list2['iepg']['regdow']	= 'M-F';
			scanList($list2, $tab);
		}
		return TRUE;
	}

	foreach ($displayed as $disp) {
		$regdow	= '';
		if ($thistab == 'scheduled') {
			if ($disp['yyyymmdd'] != $yyyymmdd) {
				continue;
			}
			$dow	= $disp['dow'];
		} else {
			$dow	= $iepg['every'];
			$regdow	= $dow;
			if ($disp['dow'] != $dow) {
				continue;
			}
			if (@$iepg['regdow']) {
				$regdow	= $iepg['regdow'];
			}
		}
		$channel = @$iepg['d-channel'] ? $iepg['d-channel'] : $iepg['channel'];
		$sched = array('yyyymmdd'	=> @$yyyymmdd,
							'dow'		=> $dow,
							'regdow'	=> $regdow,
							'tab'		=> $tab,
							'fbasename'	=> $list['fbasename'],
							'para'		=> 0,	// Will include myself
							'start'		=> $iepg['start'],
							'end'		=> $iepg['end'],
							'skey'		=> tlkey($iepg, 'start'),
							'ekey'		=> tlkey($iepg, 'end'),
							'program-title'	=> @$iepg['program-title'],
							'program-subtitle'	=> @$iepg['program-subtitle'],
							'station'	=> $iepg['station'],
							'pid'		=> 0,
							'at-job'	=> 0,
							'program_id'=> @$iepg['program_id'],
							'color'		=>
								($tab == 'recorded'
									? ($nowhhmm < $iepg['end']
										? $NOWCOLOR : $RECCOLOR)
									: $CHCOLOR[$channel]));
		if ($tab != 'recorded' || $nowhhmm < $iepg['start']) {
			$fpath = "$VIDEOROOTDIR/recorded/" . $list['fbasename'] . '.stat';
			if (@$iepg['at-job']) {
				$sched['at-job'] = $iepg['at-job'];
				$sched['pid'] = -1;
			} else if (($stat = file_get_contents($fpath)) != FALSE) {
				$sched['pid'] = sprintf("%d", $stat);
			}
			if ((!$sched['at-pid'] && !$sched['pid']) ||
				($sched['pid'] > 0 && !is_dir('/proc/' . $sched['pid']))) {
				$sched['pid'] = 0;
				$sched['color'] = $WARNCOLOR;
			}
		}
		array_push($scheduled, $sched);
		array_push($tline, $sched['skey'], $sched['ekey']);
		return TRUE;
	}
	return FALSE;
}

function addMinute($time, $min = 1) {
	sscanf($time, "%d:%d", $h, $m);
	$m += $min;
	while ($m < 0) {
		$h--;
		$m += 60;
	}
	while ($m >= 60) {
		$h++;
		$m -= 60;
	}
	return sprintf("%02d:%02d", $h, $m);
}


echo <<<END
<HTML>
<HEAD>
<STYLE TYPE="text/css">
<!--
A {text-decoration:none}
A.anchor {
	color: #000000;
}
A:visited {
	color: #000000;
}
A:hover {
	color: #ff3f00;
	text-decoration: underline;
}

table {
	height: 100%;
	width: 100%;
}
-->
</STYLE>
<meta http-equiv="content-type" content="text/html;charset=shift_jis" />
</HEAD>
<BODY>
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 RULES=COLS FRAME=BOX>
END;

// Blank cell colors (0-5,6-11,12-17,18-23) x2
$COLORS	= array(array('#d8d8ff', '#e0e0ff', '#f7e8e8', '#f7e0e0', '#f7e0e0'),
				array('#ececf7', '#f0f0f7', '#f7f0f0', '#fff0f0', '#fff0f0'));
$now	= time();
$ltime	= localtime($now, TRUE);
$nowhhmm	= sprintf("%02d:%02d", $ltime['tm_hour'], $ltime['tm_min']);
for ($i = 0; $i < count($DOW); $i++) {
	if ($thistab == 'scheduled') {
		$ltime	= localtime($now + $i * 3600 * 24, TRUE);
		$dow	= $ltime['tm_wday'];
		$year	= $ltime['tm_year']	+ 1900;
		$month	= $ltime['tm_mon']	+ 1;
		$dom	= $ltime['tm_mday'];
	} else {
		$dow	= $i;
		$year = $month = $dom	= '';
	}
	array_push($displayed, array(
				'yyyymmdd'	=> sprintf("%4d%02d%02d", @$year, @$month, @$dom),
				'month'		=> @$month,
				'dom'		=> @$dom,
				'dow'		=> $DOW[$dow],
				'irm'		=> 0,
				'para'		=> 1,
				'blnkcolor'	=> $COLORS[$i % count($COLORS)]));
}

if ($thistab == 'scheduled') {
	$today	= $displayed[0]['yyyymmdd'];
	$ntime	= sprintf("%02d:%02d", $ltime['tm_hour'], $ltime['tm_min']);
}

showDayIndex(1);

printf("<TBODY>\n");
$nofRecords	= 0;
if ($thistab == 'scheduled' && ($list = openList('recorded')) != FALSE) {
	while (readList($list)) {
		if (scanList($list, 'recorded'))
			$nofRecords++;
	}
	closeList($list);
}

if (($list = openList($thistab)) != FALSE) {
	while (readList($list)) {
		if (scanList($list, $thistab))
			$nofRecords++;
	}
	closeList($list);

	if ($nofRecords > 0) {
		array_push($tline, "06:00 M", "12:00 M", "18:00 M");
		$tline	= array_unique($tline);
		sort($tline);

		// Calculate next refresh time to update schedule/activity display
		$nowhhmmss	= sprintf("%s:%02d", $nowhhmm, $ltime['tm_sec']);
		$refhhmm	= '24:00';
		foreach ($tline as $tl) {
			if (strcmp(sprintf("%.5s:00", $tl), $nowhhmmss) > 0) {
				$refhhmm	= $tl;
				break;
			}
		}
		sscanf($refhhmm, "%d:%d", $refh, $refm);
		printf("<META HTTP-EQUIV='Refresh' CONTENT='%d'>\n",
				($refh - $ltime['tm_hour']) * 3600
				+ ($refm - $ltime['tm_min']) * 60
				- $ltime['tm_sec'] + 1);

		// Determine each scheduled program for how many rows to span
		reset($scheduled);
		foreach ($scheduled as &$sched) {
			$row	= 0;
			foreach ($tline as $tl) {
				if ($tl == $sched['skey']) {
					$srow	= $row;
				}
				sscanf($tl, "%s %s", $time, $opentl);
				if ($opentl == 'M') {
					$row += 2;
				}
				if ($tl == $sched['ekey']) {
					$erow	= $row;
					break;
				}
				$row++;
			}
			$sched['rowspan']	= ($erow - $srow) + 1;
		}
		unset($sched);

		// Determine how many cols parallel for the time
		// (Comparing with self is fine 'cuz we start with zero)
		// DO NOT COMBINE THIS WITH THE ABOVE LOOP
		//	- PHP WOULD BEAHVE STRANGELY
		$scheduled2	= $scheduled;
		foreach ($scheduled as &$sched) {
			$s	= $sched['skey'];
			$e	= $sched['ekey'];

			// We have to scan every minute
			$para	= array();
			$paramax	= 1;
			foreach ($scheduled2 as $sched2) {
				$s2 = $sched2['skey'];
				$e2 = $sched2['ekey'];
				// Overlapping?
				if (($sched[$daykey] == $sched2[$daykey])
					&& (($s <= $s2 && $s2 < $e)
						|| ($s2 <= $s && $s < $e2)
						|| ($s < $e2 && $e2 <= $e)
						|| ($s2 < $e && $e <= $e2))) {
					for ($m = $sched['skey']; $m < $sched['ekey'];
						$m = addMinute($m)) {
						if ($sched2['skey'] <= $m && $m < $sched2['ekey']) {
							if (0) {
							printf("<!--OVERLAP time %s %s-->\n",
								$sched[$daykey], $m);
							}
							@$para[$m]++;
							if ($para[$m] > $paramax)
								$paramax = $para[$m];
  						}
					}

					if ($para[$m] > 1 &&
						$sched['station'] == $sched2['station'])
						$sched['color'] = $sched2['color'] = $WARNCOLOR;
				}
			}
			if (($sched['para'] = $paramax) > $NUMVIDEODEVICES) {
				$sched['color']	= $WARNCOLOR;
			}
		}
		unset($sched);
echo "<!--";
print_r($scheduled);
echo "-->\n";
		$ptime	= '';
		while (count($tline)  > 0){
			$tl	= array_shift($tline);
			printf("\n<!--%s-->\n", $tl);
			sscanf($tl, "%s %s", $time, $opentl);

			// Determin if any day is in row span
			$someinrowspan	= 0;
			foreach ($displayed as $disp) {
				if ($disp['irm']) {
					$someinrowspan++;
				}
			}

			// New open time distant from prev close - insert a blank row
			if (!$someinrowspan && $opentl == 'S' && $time != $ptime) {
				printf("<TR>\n");
				foreach ($displayed as $disp) {
					printf("<TD %s COLSPAN=%d>&nbsp;</TD>\n",
							blnkcolor($disp, addMinute($time, -1)),
							$COLSPERDAY);
				}
				printf("</TR>\n");
			}
			$ptime	= $time;
			if ($opentl == 'M') {
				showDayIndex(0, $time);
				continue;
			}

			printf("<TR>\n");

			// Scan for each day
			foreach ($displayed as &$disp) {
				printf("<!--%s-->\n", $disp[$daykey]);
				$resetirm	= 0;

				if ($opentl == 'S') {
					// New program starts
					reset($scheduled);
					foreach($scheduled as &$sched) {
						if ($sched['skey'] == $tl
							&& $sched[$daykey] == $disp[$daykey]) {
							$disp['para']	= $sched['para'];
							for ($i = 0; $i < $sched['para']; $i++) {
								$mask	= (1 << $i);
								if (!($disp['irm'] & $mask)) {
									$disp['irm'] |= $mask;
									break;
								}
							}
							$sched['irm']	= $mask;
							$title	= $sched['program-title'];
							if ($sched['tab'] != 'recorded') {
								$title = sprintf(
					"<A HREF='javascript:void(\"%s\");' onClick=\"window.open" .
					"('6ga-panel.php?tab=%s&action=cancel&file=%s&_time=%d'," .
					"'_6ga_panel');\">%s</A>",
											$sched['fbasename'],
											$sched['tab'],
											$sched['fbasename'], time(),
											$title);
							}
							printf(
					"<TD ROWSPAN=%d COLSPAN=%d BGCOLOR=%s VALIGN=top>" .
					"<TABLE BORDER=1 BGCOLOR=%s FRAME=BOX RULES=NONE>" .
					"<TR><TD COLSPAN=2 VALIGN=top>" .
					"<FONT SIZE='-1'><B>%s</B>(%s)</FONT>" .
					"<BR>%s",
								$sched['rowspan'],
								$COLSPERDAY/$sched['para'],
								blnkcolor($disp, $time),
								$sched['color'],
								$sched['start'],
								$sched['station'],
								$title);
							if ($thistab == 'scheduled'
								&& ($sched['para'] == 1
										|| $sched['rowspan'] > 2)) {
								if (@$sched['program-subtitle'])
									printf("<BR><FONT SIZE='-1'>%s</FONT>",
										$sched['program-subtitle']);
								else if (($iepgbody = @$sched['iepg-body'])) {
									preg_replace($iepgbody, '/\\n/', "\n");
									printf("<BR><FONT SIZE='-1'>%s</FONT>",
										$iepgbody);
								}
							}
							if ($sched['tab'] == 'recorded')
								$pid = '';
							else if ($sched['at-job'])
								$pid = sprintf("<FONT SIZE=-1>[%d:%d]</FONT>",
											$sched['at-job'],
											$sched['program_id']);
							else if ($sched['pid'])
								$pid = sprintf("<FONT SIZE=-1>(%d)</FONT>",
											$sched['pid']);
							else
								$pid = '<B>[ORPHANED]</B>';
							printf("</TD></TR>\n" .
									"<TR><TD>%s</TD>" .
									"<TD VALIGN=bottom ALIGN=RIGHT>" .
									"<FONT SIZE='-1'>", $pid);
							if ($thistab == 'regular') {
								printf("%s ", $sched['regdow']);
							}
							sscanf($sched['end'], "%d:%d", $h, $m);
							printf("%02d:%02d", $h % 24, $m);
							printf("</FONT></TD></TR></TABLE></TD>\n");
						}
					}
					unset($sched);
				} else {
					reset($scheduled);
					foreach($scheduled as $sched) {
						if ($sched['ekey'] == $tl
							&& $sched[$daykey] == $disp[$daykey]) {
							$resetirm	|= $sched['irm'];
						}
					}
				}

				// Fill remainder of this day's column with blanks
				$para	= $disp['para'];
				if ($disp['irm'] != (1 << ($para + 1)) - 1) {
					$rirm	= (~$disp['irm'] & ((1 << $para) - 1));
					while ($rirm) {
						for ($i = $para; $i > 0; $i--) {
							$mask	= (1 << $i) - 1;
							if (($rirm & $mask) == $mask) {
								printf(
						"<TD %s COLSPAN=%d><!--PFILLER-->&nbsp;</TD>\n",
									blnkcolor($disp, $time),
									($COLSPERDAY/$para) * $i);
							} else if ($rirm & $mask) {
								continue;
							}
							$rirm >>= $i;
							break;
						}
					}
				}

				$disp['irm'] &= ~$resetirm;
			}
			unset($disp);
			printf("</TR>\n");
		}
		showDayIndex(1, '23:59');
	}
}

if ($nofRecords == 0) {
	printf("<TR><TD COLSPAN=%d><CENTER>No %s programs</CENTER></TD></TR>\n",
			count($displayed) * $COLSPERDAY, 'scheduled');
}
printf("</TBODY>\n");
?>
</TABLE>
</BODY>
</HTML>
